//
// ProductAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class ProductAPI {
    /**

     - parameter color: (query)  (optional)
     - parameter manufacturer: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiProductGetSmartPhoneGet(color: String? = nil, manufacturer: String? = nil, completion: @escaping ((_ data: ProductResponseArrayResponseModel?,_ error: Error?) -> Void)) {
        apiProductGetSmartPhoneGetWithRequestBuilder(color: color, manufacturer: manufacturer).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - GET /api/Product/GetSmartPhone
     - 

     - examples: [{contentType=application/json, example={
  "Data" : [ {
    "OperatingSystem" : "OperatingSystem",
    "Color" : "Color",
    "Manufacturer" : "Manufacturer",
    "Name" : "Name"
  }, {
    "OperatingSystem" : "OperatingSystem",
    "Color" : "Color",
    "Manufacturer" : "Manufacturer",
    "Name" : "Name"
  } ],
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter color: (query)  (optional)
     - parameter manufacturer: (query)  (optional)

     - returns: RequestBuilder<ProductResponseArrayResponseModel> 
     */
    open class func apiProductGetSmartPhoneGetWithRequestBuilder(color: String? = nil, manufacturer: String? = nil) -> RequestBuilder<ProductResponseArrayResponseModel> {
        let path = "/api/Product/GetSmartPhone"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "Color": color, 
                        "Manufacturer": manufacturer
        ])


        let requestBuilder: RequestBuilder<ProductResponseArrayResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
